#import <UIKit/UIKit.h>
#import <UIKit/UIKeyboard.h>

#import "editor.h"


@implementation EditorApplication

- (void) applicationDidFinishLaunching: (id) unused
{
    struct CGRect screenRect = [UIHardware fullScreenApplicationContentRect];
    screenRect.origin = CGPointZero;

    /* EBhE */
    UIWindow *window;
	
    window = [[UIWindow alloc] initWithContentRect: screenRect];
    [window orderFront: self];
    [window makeKey: self];
    [window _setHidden: NO];

    /* \̈̐ݒ */
    struct CGRect mainRect = [UIHardware fullScreenApplicationContentRect];
    mainView = [[UIView alloc] initWithFrame: screenRect];

    /* L[{[h̑傫 */
    struct CGSize keyboardSize = [UIKeyboard defaultSize];

    /* eLXg͗ */
    textView = [[UITextView alloc]
        initWithFrame: CGRectMake(0, 0, screenRect.size.width,
        screenRect.size.height-keyboardSize.height)];
    [textView setEditable: YES];
    [textView setTextSize: 14];

    /* \tgEFAL[{[h */
    UIKeyboard *keyboard = [[UIKeyboard alloc]
        initWithFrame: CGRectMake(0, screenRect.size.height-keyboardSize.height,
        screenRect.size.width, keyboardSize.height)];

    /* t@C */
    NSString *filename;
    filename = @"/var/root/memo.txt";
    
    /* t@C烁ǂtextViewɃZbg */
    [textView setText:
        [NSMutableString
            stringWithContentsOfFile: filename
            encoding: NSUTF8StringEncoding
            error: NULL]]; 
            
    /* EBhEɕ\̈ݒ */
    [window setContentView: mainView];

    /* \̈ɃeLXg͗ݒ */
    [mainView addSubview: textView];

    /* \̈ɃL[{[hݒ */
    [mainView addSubview: keyboard];
    _bSelectMode = FALSE;
    
    [textView setEnabledGestures: 2];
	[textView setValue: [NSNumber numberWithBool: NO] forGestureAttribute: 7];
	[textView setValue: [NSNumber numberWithBool: NO] forGestureAttribute: 4];
	[textView setValue: [NSNumber numberWithBool: YES] forGestureAttribute: 5];



    
}

- (BOOL)canHandleGestures;
{
	return YES;
}


- (void)gestureEnded:(struct GSEvent *)event
{
	if(FALSE == _bSelectMode)
	{

		NSRange range = [textView selectionRange];
		_textStart = range.location;
		_bSelectMode = TRUE;
	}
	else
	{
		NSRange range = [textView selectionRange];
		NSRange selectRange;
		NSMutableString *selectText;
		if(_textStart != range.location)
		{
			if(_textStart < range.location)
			{
				selectRange.location = _textStart;
				selectRange.length =  range.location - _textStart;
			}
			else
			{
				selectRange.location = range.location ;
				selectRange.length =  _textStart - range.location ;		
			}
			selectText = [[textView text] substringWithRange:selectRange];
			
			UIAlertSheet *alert = [[[UIAlertSheet alloc] init] autorelease];
			[alert setDelegate: self];
			[alert setTitle: @"Clipboard"];
			[alert addButtonWithTitle: @"Copy"];
			[alert addButtonWithTitle: @"Cancel"];
			[alert setBodyText:selectText];
			[alert setBodyTextMaxLineCount:5];
			[alert popupAlertAnimated: YES];
			[alert setTag: 2];
						
			_bSelectMode = FALSE;
        	
		}
	
	
	}
}
- (void)alertSheet:(UIAlertSheet*)sheet buttonClicked:(int)button
{
	if( [sheet tag] == 1 ) 
	{


	}
	[sheet dismissAnimated: YES];
}


@end
